-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Tonic.Utils.Class";
import "Tonic.UI.Window";
import "Tonic.TonicBars.Bars.Inventory.InventoryBaseBar";

TabbedBar = class( Tonic.TonicBars.Bars.Inventory.InventoryBaseBar );

function TabbedBar:Constructor( barid )
	self.id = barid;

	local thebarSettings = theSettingsManager:GetBarSettings( self.id );
	if ( thebarSettings.barType ~= TABBED_INV_BAR ) then
		thebarSettings.barType = TABBED_INV_BAR;
		thebarSettings.quickslotRows = 1;
		thebarSettings.quickslotColumns = 4;
		thebarSettings.quickslotCount = 12;
		thebarSettings.visible = true;
		theSettingsManager:SetBarSettings( self.id, thebarSettings );
	end

	Tonic.TonicBars.Bars.Inventory.InventoryBaseBar.Constructor( self );
	self:SetPosition( 10, 41 );
end

function TabbedBar:Create()
	Tonic.TonicBars.Bars.Inventory.InventoryBaseBar.Create( self );

	self.quickslotTab = Turbine.UI.ListBox();
	self.quickslotTab:SetParent( self );
	self.quickslotTab:SetSize( self:GetWidth() * 0.5, 10 );
	self.quickslotTab:SetPosition( self:GetWidth() - self.quickslotTab:GetWidth(), 0 );
	self.quickslotTab:SetBackColor( Turbine.UI.Color(0,0,0,0)  );

	self.quickslotList:SetPosition(0, self.quickslotTab:GetHeight() );
	self:SetBarSize();

	self.quickslotTab.MouseDown = function( sender, args )
		self:MouseDown(args);
	end
	self.quickslotTab.MouseMove = function( sender, args )
		self:MouseMove(args);
	end
	self.quickslotTab.MouseUp = function( sender, args )
		self:MouseUp(args);
	end
end

function TabbedBar:SetBarSize(xsize, ysize)
	if ( self.quickslotTab ~= nil ) then
		self:SetSize( self.quickslotList:GetWidth(), self.quickslotList:GetHeight() + self.quickslotTab:GetHeight() );
	end
end

function TabbedBar:SetBGColor( color )
	self:SetBackColor( color );
	self:ClearTab( clearTab );
end

function TabbedBar:ClearTab( cTab )
	if ( self.quickslotTab == nil ) then
		return;
	end
	local settings = theSettingsManager:GetSettings();
	if ( settings.barMode == NORMAL_MODE ) then
		self.clearTab = cTab;
		self.quickslotTab:SetSize( self:GetWidth(), 10 );
	else
		self.clearTab = false;
		self.quickslotTab:SetSize( self:GetWidth() * 0.5, 10 );
	end
end

function TabbedBar:Refresh()
	Tonic.TonicBars.Bars.Inventory.InventoryBaseBar.Refresh( self );
	local settings = theSettingsManager:GetSettings();
	
	if ( self.quickslotTab ~= nil ) then
		if ( self.clearTab ~= nil and self.clearTab and settings.barMode == NORMAL_MODE ) then
			self.quickslotTab:SetSize( self:GetWidth(), 10 );
		else
			self.quickslotTab:SetSize( self:GetWidth() * 0.5, 10 );
		end
		self.quickslotTab:SetPosition( self:GetWidth() - self.quickslotTab:GetWidth(), 0 );
	end
end

function TabbedBar:SetMenuBackColor( selected )
	Tonic.TonicBars.Bars.BaseBar.SetMenuBackColor( self, selected, INVENTORY_MODE );
	self:SetBackColor( Turbine.UI.Color(1,1,1,1) );
end