-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine.Gameplay";
import "Turbine.UI";
import "Tonic.Utils.Class";
import "Tonic.Utils.Table";

StatEvents = class( Turbine.Object  );

function StatEvents:Constructor( regEvents )
	self.registeredEvents = regEvents;
	
	eventManager.AddCallback( self, player, "MoraleChanged", function( sender, args )
		local value = player:GetMorale() / player:GetMaxMorale();
		if ( value ~= 1 ) then
			self.registeredEvents.healthTriggerActive = value;
		else
			self.registeredEvents.healthTriggerActive = nil;
		end
		eventManager:NotifyClients();
	end);
	eventManager.AddCallback( self, player, "PowerChanged", function( sender, args )
		local value = player:GetPower() / player:GetMaxPower();
		if ( value ~= 1 ) then
			self.registeredEvents.powerTriggerActive = value;
		else
			self.registeredEvents.powerTriggerActive = nil;
		end
		eventManager:NotifyClients();
	end);
end

function StatEvents:CheckVisibility( barSettings )
	local visible = false;
	if ( (self.registeredEvents.healthTriggerActive ~= nil and barSettings.events.healthTrigger ~= nil and
		  self.registeredEvents.healthTriggerActive <= barSettings.events.healthTrigger and 
		  barSettings.events.displayOnHealth) or 
		 (self.registeredEvents.powerTriggerActive ~= nil and barSettings.events.powerTrigger ~= nil and
		  self.registeredEvents.powerTriggerActive <= barSettings.events.powerTrigger and 
		  barSettings.events.displayOnPower) ) then
		visible = true;
	end
	return visible;
end