-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.MenuUtils";

ClassBuffPanel = class( Tonic.UI.AutoListBox );

function ClassBuffPanel:Constructor()
	Tonic.UI.AutoListBox.Constructor( self );

	self.utils = Tonic.UI.MenuUtils();

	self.utils:AddCategoryBox(self, LOCALESTRINGS.QuickslotsMenu["Class Triggers"]);
	
	self.utils:AddLabelBox( self, LOCALESTRINGS.ClassTriggerType["Triggered When:"], 120, selectionHeight );
	self.triggerList = Tonic.UI.ComboBox();
	self.triggerList:SetSize( 200, 20 );
	self.triggerList:SetParent( self );
	self.triggerList:AddItem( LOCALESTRINGS.ClassTriggerType["Buffs Active"], 1 );
	self.triggerList:AddItem( LOCALESTRINGS.ClassTriggerType["Buffs Not Active"], 2 );
	self:AddItem( self.triggerList );
	
	self.fadeOpacityNum1 = self.utils:AddLabelBox( self, "", 50, selectionHeight );
	
	local events = eventManager:GetRegisteredEvents();
	self.eventCheckboxes = { };
	local count = 0;
	local box = nil;
	
	local box11 = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
	if ( events.classes ~= nil and events.classes[playerClass] ~= nil and events.classes[playerClass].effects ~= nil ) then
		local curIndex = 0;
		local tempKey, tempValue;
		local numItems = 0;
		for key, value in pairs (events.classes[playerClass].effects) do
			numItems = numItems + 1;
		end
		while (curIndex + 1) <= numItems do
			curIndex = curIndex + 1;
			for key, value in pairs (events.classes[playerClass].effects) do
				if ( value.index == curIndex ) then
					tempKey = key;
					tempValue = value;
				end
			end
			if ( count % 2 == 0 ) then
				box = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Horizontal, 0, 0, 0, 0 );
			end
			for key, value in pairs (events.classes[playerClass].effects) do
				if ( key == tempKey ) then
					self.eventCheckboxes[key] = self.utils:AddCheckBox( box, tempValue.description, selectionWidth + 15, selectionHeight );
					self.utils:CreateCheckBoxCallback( self.eventCheckboxes[key], { "events", "effects", key } );
				end
			end
			if ( count % 2 == 1 ) then
				box11:AddItem( box );
			end
			count = count + 1;
		end
	end
	-- because of the count = count + 1;
	if ( count % 2 == 1 ) then
		box11:AddItem( box );
	end
	self:AddItem( box11 );
	
	local box13 = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
	if ( player:GetClass() == Turbine.Gameplay.Class.Burglar ) then
	elseif ( player:GetClass() == Turbine.Gameplay.Class.Champion ) then
		self.eventCheckboxes[CHAMPION_FERVOR] = self.utils:AddCheckBox( box13, LOCALESTRINGS.ClassTriggers["Fervor between:"], selectionWidth + 15, selectionHeight );
		self.eventCheckboxes[CHAMPION_FERVOR].CheckedCallback = function( sender, args )
			local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
			if ( self.eventCheckboxes[CHAMPION_FERVOR].IsChecked ) then
				if ( barSettings.events == nil ) then
					barSettings.events = { }; 
				end
				if ( barSettings.events.classRange == nil ) then
					barSettings.events.classRange = { };
				end
				barSettings.events.classRange[CHAMPION_FERVOR] = { };
				barSettings.events.classRange[CHAMPION_FERVOR].minValue = 1;
				barSettings.events.classRange[CHAMPION_FERVOR].maxValue = 1;
				self.championSbMin:SetValue( 1 );
				self.championSbMax:SetValue( 5 );
			elseif ( barSettings.events ~= nil and barSettings.events.classRange ~= nil and barSettings.events.classRange[CHAMPION_FERVOR] ~= nil) then
				self.championSbMin:SetValue( 0 );
				self.championSbMax:SetValue( 0 );
				barSettings.events.classRange[CHAMPION_FERVOR].maxValue = nil;
				barSettings.events.classRange[CHAMPION_FERVOR].minValue = nil;
				barSettings.events.classRange[CHAMPION_FERVOR] = nil;
			end
			theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
		end
		self.utils:AddLabelBox( box13, LOCALESTRINGS.QuickslotsMenu["Attunement is set with: 10 is Balanced, Lower numbers are Battle and Higher numbers are Healing"], 50, selectionHeight );

		box = self.utils:AddAutoListBox( box13, Turbine.UI.Orientation.Horizontal, 0, 0, 0, 0 );
		boxSet1 = self.utils:AddAutoListBox( box, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
		boxSet2 = self.utils:AddAutoListBox( box, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );

		self.utils:AddLabelBox( boxSet1, LOCALESTRINGS.QuickslotsMenu["Min:"], 50, selectionHeight );
		self.championSbMin = self.utils:AddScrollBar( boxSet1, 1, 1, 5, 100, selectionHeight + 15 );
		self.utils:CreateScrollBarCallback( self.championSbMin, { "events", "classRange", CHAMPION_FERVOR, "minValue" } );

		self.utils:AddLabelBox( boxSet2, LOCALESTRINGS.QuickslotsMenu["Max:"], 50, selectionHeight );
		self.championSbMax = self.utils:AddScrollBar( boxSet2, 1, 1, 5, 100, selectionHeight + 15 );
		self.utils:CreateScrollBarCallback( self.championSbMax, { "events", "classRange", CHAMPION_FERVOR, "maxValue" } );
		self.championSbMin:SetValue( 0 );
		self.championSbMax:SetValue( 0 );
		box:AddItem( boxSet1 );
		box:AddItem( boxSet2 );
		box13:AddItem( box );
	elseif ( player:GetClass() == Turbine.Gameplay.Class.RuneKeeper ) then
		self.eventCheckboxes[RK_ATTUNEMENT] = self.utils:AddCheckBox( box13, LOCALESTRINGS.ClassTriggers["Attunement between:"], selectionWidth + 15, selectionHeight );
		self.eventCheckboxes[RK_ATTUNEMENT].CheckedCallback = function( sender, args )
			local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
			if ( self.eventCheckboxes[RK_ATTUNEMENT].IsChecked ) then
				if ( barSettings.events == nil ) then
					barSettings.events = { }; 
				end
				if ( barSettings.events.classRange == nil ) then
					barSettings.events.classRange = { };
				end
				barSettings.events.classRange[RK_ATTUNEMENT] = { };
				barSettings.events.classRange[RK_ATTUNEMENT].minValue = 1;
				barSettings.events.classRange[RK_ATTUNEMENT].maxValue = 1;
				self.rkSbMin:SetValue( 1 );
				self.rkSbMax:SetValue( 19 );
			elseif ( barSettings.events ~= nil and barSettings.events.classRange ~= nil and barSettings.events.classRange[RK_ATTUNEMENT] ~= nil) then
				self.rkSbMin:SetValue( 0 );
				self.rkSbMax:SetValue( 0 );
				barSettings.events.classRange[RK_ATTUNEMENT].maxValue = nil;
				barSettings.events.classRange[RK_ATTUNEMENT].minValue = nil;
				barSettings.events.classRange[RK_ATTUNEMENT] = nil;
			end
			theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
		end
		self.utils:AddLabelBox( box13, LOCALESTRINGS.QuickslotsMenu["Attunement is set with: 10 is Balanced, Lower numbers are Battle and Higher numbers are Healing"], 50, selectionHeight );
		box = self.utils:AddAutoListBox( box13, Turbine.UI.Orientation.Horizontal, 0, 0, 0, 0 );
		boxSet1 = self.utils:AddAutoListBox( box, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
		boxSet2 = self.utils:AddAutoListBox( box, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );

		self.utils:AddLabelBox( boxSet1, LOCALESTRINGS.QuickslotsMenu["Min:"], 50, selectionHeight );
		self.rkSbMin = self.utils:AddScrollBar( boxSet1, 1, 1, 19, 100, selectionHeight + 20 );
		self.utils:CreateScrollBarCallback( self.rkSbMin, { "events", "classRange", RK_ATTUNEMENT, "minValue" } );

		self.utils:AddLabelBox( boxSet2, LOCALESTRINGS.QuickslotsMenu["Max:"], 50, selectionHeight );
		self.rkSbMax = self.utils:AddScrollBar( boxSet2, 1, 1, 19, 100, selectionHeight + 20 );
		self.utils:CreateScrollBarCallback( self.rkSbMax, { "events", "classRange", RK_ATTUNEMENT, "maxValue" } );

		self.rkSbMin:SetValue( 0 );
		self.rkSbMax:SetValue( 0 );
		box:AddItem( boxSet1 );
		box:AddItem( boxSet2 );
		box13:AddItem( box );
	elseif ( player:GetClass() == Turbine.Gameplay.Class.Hunter ) then
		self.eventCheckboxes[HUNTER_FOCUS] = self.utils:AddCheckBox( box13, LOCALESTRINGS.ClassTriggers["Focus between:"], selectionWidth + 15, selectionHeight );
		self.eventCheckboxes[HUNTER_FOCUS].CheckedCallback = function( sender, args )
			local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
			if ( self.eventCheckboxes[HUNTER_FOCUS].IsChecked ) then
				if ( barSettings.events == nil ) then
					barSettings.events = { }; 
				end
				if ( barSettings.events.classRange == nil ) then
					barSettings.events.classRange = { };
				end
				barSettings.events.classRange[HUNTER_FOCUS] = { };
				barSettings.events.classRange[HUNTER_FOCUS].minValue = 1;
				barSettings.events.classRange[HUNTER_FOCUS].maxValue = 1;
				self.hunterSbMin:SetValue( 1 );
				self.hunterSbMax:SetValue( 9 );
			elseif ( barSettings.events ~= nil and barSettings.events.classRange ~= nil and barSettings.events.classRange[HUNTER_FOCUS] ~= nil) then
				self.hunterSbMin:SetValue( 0 );
				self.hunterSbMax:SetValue( 0 );
				barSettings.events.classRange[HUNTER_FOCUS].maxValue = nil;
				barSettings.events.classRange[HUNTER_FOCUS].minValue = nil;
				barSettings.events.classRange[HUNTER_FOCUS] = nil;

			end
			theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
		end
		box = self.utils:AddAutoListBox( box13, Turbine.UI.Orientation.Horizontal, 0, 0, 0, 0 );
		boxSet1 = self.utils:AddAutoListBox( box, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
		boxSet2 = self.utils:AddAutoListBox( box, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );

		self.utils:AddLabelBox( boxSet1, LOCALESTRINGS.QuickslotsMenu["Min:"], 50, selectionHeight );
		self.hunterSbMin = self.utils:AddScrollBar( boxSet1, 1, 1, 9, 100, selectionHeight + 20 );
		self.utils:CreateScrollBarCallback( self.hunterSbMin, { "events", "classRange", HUNTER_FOCUS, "minValue" } );

		self.utils:AddLabelBox( boxSet2, LOCALESTRINGS.QuickslotsMenu["Max:"], 50, selectionHeight );
		self.hunterSbMax = self.utils:AddScrollBar( boxSet2, 1, 1, 9, 100, selectionHeight + 20 );
		self.utils:CreateScrollBarCallback( self.hunterSbMax, { "events", "classRange", HUNTER_FOCUS, "maxValue" } );

		self.hunterSbMin:SetValue( 0 );
		self.hunterSbMax:SetValue( 0 );
		box:AddItem( boxSet1 );
		box:AddItem( boxSet2 );
		box13:AddItem( box );
	end
	self:AddItem( box13 );
end

function ClassBuffPanel:DisplaySettings()
	
	local localBarSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
	if ( localBarSettings.events == nil ) then
		localBarSettings.events = { };
	end
	
    self.triggerList.SelectedIndexChanged = function(sender, args)
		local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
		if ( self.triggerList:GetSelection() == 1 ) then
			barSettings.events.triggerOnClassBuffActive = true;
		else
			barSettings.events.triggerOnClassBuffActive = false;
		end
		theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
	end
	if ( localBarSettings.events.triggerOnClassBuffActive ) then
		self.triggerList:SetSelection( 1 );
	else
		self.triggerList:SetSelection( 2 );
	end

	if ( self.championSbMin ~= nil and localBarSettings.events ~= nil and localBarSettings.events.classRange ~= nil and localBarSettings.events.classRange[CHAMPION_FERVOR] ~= nil ) then
		if ( localBarSettings.events.classRange[CHAMPION_FERVOR] ~= nil ) then
			self.championSbMin:SetValue( localBarSettings.events.classRange[CHAMPION_FERVOR].minValue );
			self.championSbMax:SetValue( localBarSettings.events.classRange[CHAMPION_FERVOR].maxValue );
		else
			self.championSbMin:SetValue( 0 );
			self.championSbMax:SetValue( 0 );
		end
	end
	if ( self.hunterSbMin ~= nil ) then
		if ( localBarSettings.events ~= nil and localBarSettings.events.classRange ~= nil and localBarSettings.events.classRange[HUNTER_FOCUS] ~= nil ) then
			if ( localBarSettings.events.classRange[HUNTER_FOCUS] ~= nil ) then
				self.hunterSbMin:SetValue( localBarSettings.events.classRange[HUNTER_FOCUS].minValue );
				self.hunterSbMax:SetValue( localBarSettings.events.classRange[HUNTER_FOCUS].maxValue );
			else
				self.hunterSbMin:SetValue( 0 );
				self.hunterSbMax:SetValue( 0 );
			end
		end
	end
	if ( self.rkSbMin ~= nil ) then
		if ( localBarSettings.events ~= nil and localBarSettings.events.classRange ~= nil and localBarSettings.events.classRange[RK_ATTUNEMENT] ~= nil ) then
			if ( localBarSettings.events.classRange[RK_ATTUNEMENT] ~= nil ) then
				self.rkSbMin:SetValue( localBarSettings.events.classRange[RK_ATTUNEMENT].minValue );
				self.rkSbMax:SetValue( localBarSettings.events.classRange[RK_ATTUNEMENT].maxValue );
			else
				self.rkSbMin:SetValue( 0 );
				self.rkSbMax:SetValue( 0 );
			end
		end
	end
	
	if ( self.eventCheckboxes ~= nil ) then
		for key, value in pairs (self.eventCheckboxes) do
			local checked = false;
			if ( localBarSettings.events.effects ~= nil and localBarSettings.events.effects[key] ~= nil ) then
				checked = true;
			end
			if ( localBarSettings.events.classRange ~= nil and localBarSettings.events.classRange[key] ~= nil ) then
				checked = true;
			end
			value:SetChecked( checked );
		end
	end
end

function ClassBuffPanel:EnableTriggers( enabled )
	for key, value in pairs (self.eventCheckboxes) do
		value:SetDisabled( not enabled );
	end
end
