-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.MenuUtils";

GeneralPanel = class( Tonic.UI.AutoListBox );

function GeneralPanel:Constructor()
	Tonic.UI.AutoListBox.Constructor( self );

	self.utils = Tonic.UI.MenuUtils();

	local box0 = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Horizontal, 0, 0, 0, 0 );

	self.utils:AddLabelBox( box0, LOCALESTRINGS.QuickslotsMenu["Name:"], 80, selectionHeight );
	self.barName = self.utils:AddTextBox(box0, "", selectionWidth, selectionHeight + 10 );

	local nameButton = Turbine.UI.Lotro.Button();
	nameButton:SetText( LOCALESTRINGS.QuickslotsMenu["Set"] );
	nameButton:SetSize( buttonWidth, selectionHeight );
	nameButton.MouseClick = function( sender, args )
		local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
		barSettings.barName = self.barName:GetText();
		theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
		menu:RefreshComboBox();
	end
	box0:AddItem( nameButton );
	
	self.utils:AddCategoryBox(self, LOCALESTRINGS.QuickslotsMenu["General"]);

	self:AddItem( box0 );
	self.barLockedCheckBox = self.utils:AddCheckBox( self, LOCALESTRINGS.QuickslotsMenu["Locked"], selectionWidth, selectionHeight );
	self.utils:CreateCheckBoxCallback( self.barLockedCheckBox, { "locked" } );
	
	self.utils:AddLabelBox( self, LOCALESTRINGS.QuickslotsMenu["Bar Visibility?"], 120, selectionHeight );
	self.visibilityList = Tonic.UI.ComboBox();
	self.visibilityList:SetSize( 200, 20 );
	self.visibilityList:SetParent( self );
	self.visibilityList:AddItem( LOCALESTRINGS.QuickslotVisibility["Always"], 1 );
	self.visibilityList:AddItem( LOCALESTRINGS.QuickslotVisibility["Triggered"], 2 );
	self:AddItem( self.visibilityList );
	
	self.utils:AddLabelBox( self, "", 50, 50 );
end

function GeneralPanel:DisplaySettings()
	local localBarSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
	self.barName.FocusLost = function(sender, args)
		local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
		barSettings.barName = self.barName:GetText();
		theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );		
	end
	self.barName:SetText( localBarSettings.barName );
	
    self.visibilityList.SelectedIndexChanged = function(sender, args)
		local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
		if ( self.visibilityList:GetSelection() == 1 ) then
			barSettings.visible = true;
		else
			barSettings.visible = false;
		end
		theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
		
		menu:EnableTriggers( not barSettings.visible );
	end
	if ( localBarSettings.visible ) then
		self.visibilityList:SetSelection( 1 );
	else
		self.visibilityList:SetSelection( 2 );
	end
	self.barLockedCheckBox:SetChecked( localBarSettings.locked );
end

function GeneralPanel:EnableTriggers( enabled )
end
