-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.MenuUtils";

SlotsPanel = class( Tonic.UI.AutoListBox );

function SlotsPanel:Constructor( RowColumnBased, sizeOption )
	Tonic.UI.AutoListBox.Constructor( self );
	self.RowColumnBased = RowColumnBased;
	self.utils = Tonic.UI.MenuUtils();

	self.utils:AddCategoryBox(self, LOCALESTRINGS.QuickslotsMenu["Quick Slots"]);

	local box2a = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical );
	local box2b = self.utils:AddAutoListBox( self.box2a, Turbine.UI.Orientation.Horizontal );

	if ( self.RowColumnBased == true ) then
		self.label1 = self.utils:AddLabelBox( box2a, LOCALESTRINGS.QuickslotsMenu["Rows:"], selectionWidth + 100, selectionHeight + 5 );
		self.sb = self.utils:AddScrollBar( box2b, 1, 1, 50, 200, selectionHeight + 20 );
	
		box2a:AddItem( box2b );
		self:AddItem( box2a );
		local box3a = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical );
		local box3b = self.utils:AddAutoListBox( self.box3a, Turbine.UI.Orientation.Horizontal );
	
		self.label2 = self.utils:AddLabelBox( box3a, LOCALESTRINGS.QuickslotsMenu["Columns:"], selectionWidth + 100, selectionHeight + 5 );
		self.sb2 = self.utils:AddScrollBar( box3b, 1, 1, 50, 200, selectionHeight + 20 );
	
		box3a:AddItem( box3b );
		self:AddItem( box3a );
	else
		self.utils:AddLabelBox( box2a, LOCALESTRINGS.ExtensionsMenu["Count:"], selectionWidth + 100, selectionHeight + 5 );
		self.extSb = self.utils:AddScrollBar( box2b, 1, 1, 50, 200, selectionHeight + 20 );
		self.utils:CreateScrollBarCallback( self.extSb, { "quickslotCount" }, nil, nil, function(sender,args)
			inventoryManager:NotifyClients();
		end );
		box2a:AddItem( box2b );
		self:AddItem( box2a );
	end
	local box5a = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical );
	local box5b = self.utils:AddAutoListBox( self.box5a, Turbine.UI.Orientation.Horizontal );
	self.label3 = self.utils:AddLabelBox( box5a, LOCALESTRINGS.QuickslotsMenu["Spacing:"], selectionWidth + 100, selectionHeight + 5 );
	self.spacingSB = self.utils:AddScrollBar( box5b, 1, 0, 50, 200, selectionHeight + 20 );
	self.utils:CreateScrollBarCallback( self.spacingSB, { "quickslotSpacing" } );

	box5a:AddItem( box5b );
	self:AddItem( box5a );
	local box6a = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical );
	local box6b = self.utils:AddAutoListBox( self.box6a, Turbine.UI.Orientation.Horizontal );

	self.label4 = self.utils:AddLabelBox( box6a, LOCALESTRINGS.QuickslotsMenu["Size:"], selectionWidth + 50, selectionHeight + 5 );
	self.sizeSB = self.utils:AddScrollBar( box6b, 36, 0, 99, 200, selectionHeight + 20 );
	self.utils:CreateScrollBarCallback( self.sizeSB, { "quickslotSize" }, nil, nil, function(sender,args)
		maitre_d:RefreshBars();
	end );

	box6a:AddItem( box6b );
	self:AddItem( box6a );
end

function SlotsPanel:DisplaySettings()
	local localBarSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );

	if ( self.RowColumnBased == true ) then
		self.sb.ValueChanged = function( sender, args )
			local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
			barSettings.quickslotRows = self.sb:GetValue();
			barSettings.quickslotCount = barSettings.quickslotRows * barSettings.quickslotColumns;
			theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
			inventoryManager:NotifyClients();
		end	
		self.sb:SetValue( localBarSettings.quickslotRows );
		self.sb2.ValueChanged = function( sender, args )
			local barSettings = theSettingsManager:GetBarSettings( menu:GetSelection() );
			barSettings.quickslotColumns = self.sb2:GetValue();
			barSettings.quickslotCount = barSettings.quickslotRows * barSettings.quickslotColumns;
			theSettingsManager:SetBarSettings( menu:GetSelection(), barSettings );
			inventoryManager:NotifyClients();
		end	
		self.sb2:SetValue( localBarSettings.quickslotColumns );
	else
		self.extSb:SetValue( localBarSettings.quickslotCount );
	end
	self.spacingSB:SetValue( localBarSettings.quickslotSpacing );
	self.sizeSB:SetValue( localBarSettings.quickslotSize );
end

function SlotsPanel:EnableTriggers( enabled )
end
